#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Data::Filter::Rule::OperationUnary class and it`s subclassess tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
# Comments:
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 13;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Data::Filter::Rule::OperationUnary';

        use_ok('Tester');
        use_ok('Data::Filter::Rule');
        use_ok('Data::Filter::Rule::Operation');
        use_ok('Data::Core');
        use_ok($TESTED_CLASS);
        use_ok('Data::Filter::Rule::Variable');
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
diag("$TESTED_CLASS version: " . $Data::Filter::Rule::OperationUnary::VERSION) if Tester::D();

# Prepare the operands
my $op1 = Data::Filter::Rule::Variable->new('variable', 'Node/Name');
isa_ok($op1, 'Data::Filter::Rule::Variable');

# Now attempt to create a class instance and check it
my $instance = $TESTED_CLASS->new('not', $op1);
isa_ok($instance, $TESTED_CLASS);

# Test the rule interface
is($instance->value(),     undef,              "Rule interface test 01");
is($instance->datatype(),  'BOOL',             "Rule interface test 02");
is($instance->operation(), 'NOT',              "Rule interface test 03");
is($instance->name(),      'OperationUnary',   "Rule interface test 04");
is($instance->to_string(), '(NOT Node/Name)',  "Rule interface test 05");

# View the created instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D();
